#!/bin/bash

set -u

for goosarch in $(go tool dist list | grep -vw -e aix -e js/wasm -e plan9 -e solaris -e android -e nacl)
do
    mkdir -p "build/$goosarch"
    goos=$(cut -d/ -f 1 <<<$goosarch)
    goarch=$(cut -d/ -f 2 <<<$goosarch)
    for cmd in cmd/*; do
        GOOS=${goos} GOARCH=${goarch} go build -o "build/$goos/$goarch/$(basename $cmd)" ./$cmd
    done
done

find build/ -type f|cut -d/ -f 1-3|uniq|while read -r dir; do
    find $dir/ -type f -executable | xargs sha1sum > $dir/SHA1SUMS.txt
    # TODO: touch to last commit date maybe
    find build -exec touch -d @1234567890 {} \;
    zip -q -X -j -r "circolog-$(git describe --tags --always)-$(cut -d/ -f 2-3 <<<"$dir"|tr / -)" "$dir"
done
